package nce.editor.prefs;

import nce.ColoringEditorPlugin;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.PreferenceConverter;
import org.eclipse.swt.graphics.RGB;


public class PreferenceInitializer extends AbstractPreferenceInitializer {

    public PreferenceInitializer() {
        super();
    }

    public void initializeDefaultPreferences() {
        IPreferenceStore store = ColoringEditorPlugin.getDefault().getPreferenceStore();
        initDefaultColors(store);
    }

	private static void initDefaultColors(IPreferenceStore store) {
		
		PreferenceConverter.setDefault(store, ColorsPreferencePage.NULL_COLOR, new RGB(0, 0, 0));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.COMMENT1_COLOR, new RGB(128,128,128));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.COMMENT2_COLOR, new RGB(255,132,0));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.COMMENT3_COLOR, new RGB(64,192,64));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.COMMENT4_COLOR, new RGB(192,64,192));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.LITERAL1_COLOR, new RGB(255,0,204));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.LITERAL2_COLOR, new RGB(213,234,255));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.LITERAL3_COLOR, new RGB(64,64,64));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.LITERAL4_COLOR, new RGB(128,128,128));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.LABEL_COLOR, new RGB(255,128,0));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.KEYWORD1_COLOR, new RGB(0,102,153));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.KEYWORD2_COLOR, new RGB(0,153,102));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.KEYWORD3_COLOR, new RGB(0,153,255));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.KEYWORD4_COLOR, new RGB(255,128,128));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.FUNCTION_COLOR, new RGB(153,102,255));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.MARKUP_COLOR, new RGB(0,0,255));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.OPERATOR_COLOR, new RGB(0,0,0));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.DIGIT_COLOR, new RGB(255,0,0));
		PreferenceConverter.setDefault(store, ColorsPreferencePage.INVALID_COLOR, new RGB(255,255,128));
		
		String bold = ColorsPreferencePage.BOLD_SUFFIX;
		store.setDefault(ColorsPreferencePage.NULL_COLOR + bold,  false);
		store.setDefault(ColorsPreferencePage.COMMENT1_COLOR + bold, false);
		store.setDefault(ColorsPreferencePage.COMMENT2_COLOR + bold, true);		
		store.setDefault(ColorsPreferencePage.COMMENT3_COLOR + bold, false);
		store.setDefault(ColorsPreferencePage.COMMENT4_COLOR + bold, false);		
		store.setDefault(ColorsPreferencePage.LITERAL1_COLOR + bold,  false);
		store.setDefault(ColorsPreferencePage.LITERAL2_COLOR + bold,  false);
		store.setDefault(ColorsPreferencePage.LITERAL3_COLOR + bold,  false);
		store.setDefault(ColorsPreferencePage.LITERAL4_COLOR + bold,  false);
		store.setDefault(ColorsPreferencePage.LABEL_COLOR + bold,  false);
		store.setDefault(ColorsPreferencePage.KEYWORD1_COLOR + bold,  true);
		store.setDefault(ColorsPreferencePage.KEYWORD2_COLOR + bold,  true);
		store.setDefault(ColorsPreferencePage.KEYWORD3_COLOR + bold,  true);
		store.setDefault(ColorsPreferencePage.KEYWORD4_COLOR + bold,  false);
		store.setDefault(ColorsPreferencePage.FUNCTION_COLOR + bold,  false);
		store.setDefault(ColorsPreferencePage.MARKUP_COLOR + bold,  false);
		store.setDefault(ColorsPreferencePage.OPERATOR_COLOR + bold,  false);
		store.setDefault(ColorsPreferencePage.DIGIT_COLOR + bold,  false);
		store.setDefault(ColorsPreferencePage.INVALID_COLOR + bold,  false);
	}

}
