package org.gjt.sp.jedit;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Platform;
import org.gjt.sp.util.Log;
import org.gjt.sp.util.XMLUtilities;

public class CatalogReader {

	public static void loadCatalog() {
		
		String directory = "/modes/";
		boolean resource = true;
		ModeCatalogHandler handler = new ModeCatalogHandler(directory, resource);
		try {
			URL url = getFile("modes/catalog");
			InputStream in = url.openConnection().getInputStream();
			XMLUtilities.parseXML(in, handler);
		} catch (IOException e) {
			Log.log(Log.ERROR, CatalogReader.class, "Error loading catalog", e);
		}
		
	}
	
	/**
	 * Answer the file associated with name. This handles the case of running as
	 * a plugin and running standalone which happens during testing.
	 * 
	 * @param filename
	 * @return File
	 */
	private static URL getFile(String filename) throws IOException {
		System.out.println("get file " + filename);
		// URL installURL =
		// EditorPlugin.getDefault().getDescriptor().getInstallURL();
		URL installURL = Platform.getBundle("nce.editor").getEntry("/");
		System.out.println("install url " + installURL);
		// URL mode = Platform.resolve(new URL(installURL, filename));
		return FileLocator.resolve(new URL(installURL, filename));
	}
	
}
